@
@
@    Copyright 2009 TheSeven
@
@
@    This file is part of iLoader.
@
@    TheSeven's iBugger is free software: you can redistribute it and/or
@    modify it under the terms of the GNU General Public License as
@    published by the Free Software Foundation, either version 2 of the
@    License, or (at your option) any later version.
@
@    TheSeven's iBugger is distributed in the hope that it will be useful,
@    but WITHOUT ANY WARRANTY; without even the implied warranty of
@    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
@    See the GNU General Public License for more details.
@
@    You should have received a copy of the GNU General Public License
@    along with iLoader.  If not, see <http://www.gnu.org/licenses/>.
@
@


.global _start
_start:
	b	start
	b	reset
	b	reset
	b	reset
	b	reset
	b	reset
	b	reset
	b	reset
	
start:
	ldr	r0, =__bss_start__
	ldr	r1, =__bss_end__
	mov	r2, #0
clearloop:
	cmp	r0, r1
	strle	r2, [r0], #4
	ble	clearloop

	mov	r1, #0x38000000
	orr	r1, r1, #0x200000
	ldr	r0, [r1]
	orr	r0, r0, #1
	bic	r0, r0, #0x10000
	str	r0, [r1]

	ldr sp, =__stack_top__
	bl	main

.global reset
reset:
  MOV R0, #0xD3
  MSR CPSR_c, R0
  MOV R0, #0x110000
  ADD R0, R0, #0xFF
  ADD R1, R0, #0xA00
  MOV R2, #0x3C800000
  STR R1, [R2]    
  MOV R1, #0xFF0
  STR R1, [R2,#4]
  STR R0, [R2]

.global hang
hang:
B hang


.global fillrect
fillrect:
	mov	r12, r1
fillrect_pixel:
	strh	r3, [r0], #2
	subs	r12, r12, #1
	bne	fillrect_pixel
	add	r0, r0, #352
	sub	r0, r0, r1,lsl#1
	subs	r2, r2, #1
	bne	fillrect
	mov	pc, lr


.global renderbmp
renderbmp:
	ldrh	r2, [r1]
	sub	r2, r2, #0x4d00
	subs	r2, r2, #0x42
	movne	pc, lr
	str	lr, [sp,#-4]
	ldrh	r2, [r1,#18]
	ldrh	r12, [r1,#20]
	orr	r2, r2, r12,lsl#16
	ldrh	r3, [r1,#22]
	ldrh	r12, [r1,#24]
	orr	r3, r3, r12,lsl#16
	ldrh	lr, [r1,#10]
	ldrh	r12, [r1,#12]
	orr	lr, lr, r12,lsl#16
	add	r1, r1, lr
	mov	r12, #352
	mul	lr, r12, r3
	add	r0, r0, lr
renderbmp_row:
	mov	r12, r2
	sub	r0, r0, #352
renderbmp_pixel:
	ldrb	lr, [r1,#1]
	strb	lr, [r0], #1
	ldrb	lr, [r1], #2
	strb	lr, [r0], #1
	subs	r12, r12, #1
	bne	renderbmp_pixel
	tst	r2, #1
	addne	r1, r1, #2
	sub	r0, r0, r2,lsl#1
	subs	r3, r3, #1
	bne	renderbmp_row
	ldr	pc, [sp,#-4]


.global rendertext
rendertext:
	stmfd	sp!, {r4-r7,lr}
rendertext_next:
	ldrb	r12, [r3], #1
	cmp	r12, #0
	beq	rendertext_done
	cmn	r2, #1
	beq	rendertext_nobg
	mov	r6, r0
	mov	r4, #8
	mov	lr, r2,lsr#16
	sub	lr, lr, #0xff00
	subs	lr, lr, #0xff
	bne	rendertext_opaquerow
	mov	r7, r2,lsl#16
	mov	r7, r7,lsr#16
rendertext_blendrow:
	mov	r5, #6
rendertext_blendcol:
	ldrh	lr, [r6]
	tst	lr, #1
	orrne	lr, lr, #0x10000
	mov	lr, lr,lsr#1
	bic	lr, lr, #0x1000
	bic	lr, lr, #0x84
	add	lr, lr, r7
	strh	lr, [r6], #2
	subs	r5, r5, #1
	bne	rendertext_blendcol
	add	r6, r6, #340
	subs	r4, r4, #1
	bne	rendertext_blendrow
	b	rendertext_nobg
rendertext_opaquerow:
	mov	r5, #6
rendertext_opaquecol:
	strh	r2, [r6], #2
	subs	r5, r5, #1
	bne	rendertext_opaquecol
	add	r6, r6, #340
	subs	r4, r4, #1
	bne	rendertext_opaquerow
rendertext_nobg:
	adr	r5, font
	sub	r12, r12, #0x20
	cmp	r12, #0x5f
	addcc	r5, r12,lsl#2
	addcc	r5, r12
	mov	r12, #5
rendertext_col:
	mov	r6, r0
	ldrb	r4, [r5], #1
rendertext_row:
	tst	r4, #1
	strneh	r1, [r6]
	add	r6, r6, #352
	movs	r4, r4,lsr#1
	bne	rendertext_row
	add	r0, r0, #2
	subs	r12, r12, #1
	bne	rendertext_col
	add	r0, r0, #2
	b	rendertext_next
rendertext_done:
	ldmfd sp!, {r4-r7,pc}

font:
	.byte 0, 0, 0, 0, 0
	.byte 0, 0, 95, 0, 0
	.byte 0, 7, 0, 7, 0
	.byte 20, 127, 20, 127, 20
	.byte 36, 42, 127, 42, 18
	.byte 35, 19, 8, 100, 98
	.byte 54, 73, 85, 34, 80
	.byte 5, 3, 0, 0, 0
	.byte 28, 34, 65, 0, 0
	.byte 0, 0, 65, 34, 28
	.byte 20, 8, 62, 8, 20
	.byte 8, 8, 62, 8, 8
	.byte 0, -96, 96, 0, 0
	.byte 8, 8, 8, 8, 8
	.byte 0, 96, 96, 0, 0
	.byte 32, 16, 8, 4, 2
	.byte 62, 81, 73, 69, 62
	.byte 0, 66, 127, 64, 0
	.byte 66, 97, 81, 73, 70
	.byte 33, 65, 69, 75, 49
	.byte 24, 20, 18, 127, 16
	.byte 39, 69, 69, 69, 57
	.byte 60, 74, 73, 73, 48
	.byte 1, 113, 9, 5, 3
	.byte 54, 73, 73, 73, 54
	.byte 6, 73, 73, 41, 30
	.byte 0, 54, 54, 0, 0
	.byte 0, 86, 54, 0, 0
	.byte 8, 20, 34, 65, 0
	.byte 20, 20, 20, 20, 20
	.byte 0, 65, 34, 20, 8
	.byte 2, 1, 81, 9, 6
	.byte 50, 73, 121, 65, 62
	.byte 124, 18, 17, 18, 124
	.byte 127, 73, 73, 73, 62
	.byte 62, 65, 65, 65, 34
	.byte 127, 65, 65, 34, 28
	.byte 127, 73, 73, 73, 65
	.byte 127, 9, 9, 9, 1
	.byte 62, 65, 73, 73, 58
	.byte 127, 8, 8, 8, 127
	.byte 0, 65, 127, 65, 0
	.byte 32, 64, 65, 63, 1
	.byte 127, 8, 20, 34, 65
	.byte 127, 64, 64, 64, 64
	.byte 127, 2, 12, 2, 127
	.byte 127, 4, 8, 16, 127
	.byte 62, 65, 65, 65, 62
	.byte 127, 9, 9, 9, 6
	.byte 62, 65, 81, 33, 94
	.byte 127, 9, 25, 41, 70
	.byte 38, 73, 73, 73, 50
	.byte 1, 1, 127, 1, 1
	.byte 63, 64, 64, 64, 63
	.byte 31, 32, 64, 32, 31
	.byte 127, 32, 24, 32, 127
	.byte 99, 20, 8, 20, 99
	.byte 3, 4, 120, 4, 3
	.byte 97, 81, 73, 69, 67
	.byte 0, 127, 65, 65, 0
	.byte 2, 4, 8, 16, 32
	.byte 0, 65, 65, 127, 0
	.byte 4, 2, 1, 2, 4
	.byte 64, 64, 64, 64, 64
	.byte 1, 2, 4, 0, 0
	.byte 32, 84, 84, 84, 120
	.byte 127, 68, 68, 68, 56
	.byte 56, 68, 68, 68, 40
	.byte 56, 68, 68, 68, 127
	.byte 56, 84, 84, 84, 24
	.byte 8, 126, 9, 1, 2
	.byte 8, 84, 84, 84, 60
	.byte 127, 4, 4, 4, 120
	.byte 0, 68, 125, 64, 0
	.byte 32, 64, 64, 61, 0
	.byte 127, 16, 40, 68, 0
	.byte 0, 65, 127, 64, 0
	.byte 124, 4, 24, 4, 120
	.byte 124, 8, 4, 4, 120
	.byte 56, 68, 68, 68, 56
	.byte 124, 20, 20, 20, 24
	.byte 8, 20, 20, 20, 124
	.byte 124, 8, 4, 4, 8
	.byte 72, 84, 84, 84, 32
	.byte 4, 63, 68, 64, 32
	.byte 60, 64, 64, 32, 124
	.byte 28, 32, 64, 32, 28
	.byte 60, 64, 56, 64, 60
	.byte 68, 40, 16, 40, 68
	.byte 12, 80, 80, 80, 60
	.byte 68, 100, 84, 76, 68
	.byte 0, 8, 54, 65, 0
	.byte 0, 0, 119, 0, 0
	.byte 0, 65, 54, 8, 0
	.byte 2, 1, 2, 4, 2
.align 2


sendlcd2c:
	ldr	r4, [r12,#0x1c]
	ands	r4, r4, #0x10
	bne	sendlcd2c
	mov	r4, r0,lsr#8
	str	r4, [r12,#0x04]
	and	r0, r0, #0xff
sendlcdc:
	ldr	r4, [r12,#0x1c]
	ands	r4, r4, #0x10
	bne	sendlcdc
	str	r0, [r12,#0x04]
	mov	pc, lr
sendlcd2d:
	ldr	r4, [r12,#0x1c]
	ands	r4, r4, #0x10
	bne	sendlcd2d
	mov	r4, r0,lsr#8
	str	r4, [r12,#0x40]
	and	r0, r0, #0xff
sendlcdd:
	ldr	r4, [r12,#0x1c]
	ands	r4, r4, #0x10
	bne	sendlcdd
	str	r0, [r12,#0x40]
	mov	pc, lr

.global detectlcd
detectlcd:
	mov	r12, #0x3c000000
	orr	r12, r12, #0xf00000
	ldr	r0, [r12,#0xd0]
	bic	r0, r0, #0x0f
	str	r0, [r12,#0xd0]
	ldr	r0, [r12,#0xe0]
	bic	r0, r0, #0xf0
	str	r0, [r12,#0xe0]
	ldr	r0, [r12,#0xd4]
	and	r0, r0, #1
	ldr	r1, [r12,#0xe4]
	and	r1, r1, #2
	orr	r0, r0, r1
	mov	pc, lr

.global displaylcd
displaylcd:
	stmfd	sp!, {r0,r1,r4,lr}
	bl	displaylcd_sync
	bl	detectlcd
	sub	r12, r12, #0x04900000
	cmp	r0, #2
	bne	displaylcd_othertypes
	mov	r0, #0x50
	bl	sendlcd2c
	ldr	r0, [sp]
	bl	sendlcd2d
	mov	r0, #0x51
	bl	sendlcd2c
	ldr	r0, [sp,#0x04]
	bl	sendlcd2d
	mov	r0, #0x52
	bl	sendlcd2c
	mov	r0, r2
	bl	sendlcd2d
	mov	r0, #0x53
	bl	sendlcd2c
	mov	r0, r3
	bl	sendlcd2d
	mov	r0, #0x20
	bl	sendlcd2c
	ldr	r0, [sp]
	bl	sendlcd2d
	mov	r0, #0x21
	bl	sendlcd2c
	mov	r0, r2
	bl	sendlcd2d
	mov	r0, #0x22
	bl	sendlcd2c
	b	displaylcd_blit
displaylcd_othertypes:
	mov	r0, #0x2a
	bl	sendlcdc
	ldr	r0, [sp]
	bl	sendlcd2d
	ldr	r0, [sp,#0x04]
	bl	sendlcd2d
	mov	r0, #0x2b
	bl	sendlcdc
	mov	r0, r2
	bl	sendlcd2d
	mov	r0, r3
	bl	sendlcd2d
	mov	r0, #0x2c
	bl	sendlcdc
displaylcd_blit:
	ldmia	sp, {r0,r1}
	sub	r1, r0
	add	r1, r1, #1
	sub	r3, r2
	add	r3, r3, #1
	mul	r2, r1, r3
	ldr	r1, [sp,#0x10]
	cmp	r1, #0x40000000
	bne	displaylcd_dma
displaylcd_pixel:
	ldr	r0, [sp,#0x14]
	bl	sendlcd2d
	subs	r2, r2, #1
	bne	displaylcd_pixel
	ldmfd	sp!, {r0,r1,r4,pc}
displaylcd_dma:
	mov	r3, #0x38000000
	add	r3, r3, #0x400000
	mov	r0, #0x20000000
	orr	r0, r0, #0x180000
	str	r0, [r3,#0x104]
	str	r1, [r3,#0x100]
	mov	r0, r2,lsr#1
	sub	r0, r0, #1
	str	r0, [r3,#0x108]
	bl	clean_dcache
	mov	r0, #4
	str	r0, [r3,#0x114]
	ldmfd	sp!, {r0,r1,r4,pc}

.global displaylcd_sync
displaylcd_sync:
	mov	r1, #0x38000000
	add	r1, r1, #0x400000
displaylcd_sync_wait:
	ldr	r0, [r1,#0x184]
	tst	r0, #0x40000
	bne	displaylcd_sync_wait
	mov	pc, lr


.global poweroff
poweroff:
	mov	r0, #0xe6
	mov	r1, #0x2b
	mov	r2, #0x00
	bl	i2csendbyte
	mov	r0, #0xe6
	mov	r1, #0x29
	mov	r2, #0x00
	bl	i2csendbyte
	bl	detectlcd
	sub	r12, r12, #0x04900000
	cmp	r0, #2
	beq	poweroff_lcd_type2
	mov	r0, #0x28
	bl	sendlcdc
	mov	r0, #0x10
	bl	sendlcdc
	b	poweroff_lcd_done
poweroff_lcd_type2:
	mov	r0, #0x07
	bl	sendlcd2c
	mov	r0, #0x200
	orr	r0, r0, #0x32
	bl	sendlcd2d
	mov	r0, #0x13
	bl	sendlcd2c
	mov	r0, #0x1100
	orr	r0, #0x37
	bl	sendlcd2d
	mov	r0, #0x07
	bl	sendlcd2c
	mov	r0, #0x200
	orr	r0, r0, #0x01
	bl	sendlcd2d
	mov	r0, #0x13
	bl	sendlcd2c
	mov	r0, #0x100
	orr	r0, #0x37
	bl	sendlcd2d
	mov	r0, #0x07
	bl	sendlcd2c
	mov	r0, #0x200
	bl	sendlcd2d
	mov	r0, #0x10
	bl	sendlcd2c
	mov	r0, #0x680
	bl	sendlcd2d
	mov	r0, #0x12
	bl	sendlcd2c
	mov	r0, #0x160
	bl	sendlcd2d
	mov	r0, #0x13
	bl	sendlcd2c
	mov	r0, #0x100
	orr	r0, r0, #0x27
	bl	sendlcd2d
	mov	r0, #0x10
	bl	sendlcd2c
	mov	r0, #0x600
	bl	sendlcd2d
poweroff_lcd_done:
	mov	r0, #0x100000
poweroff_wait:
	subs	r0, r0, #1
	bne	poweroff_wait
	mov	r0, #0xe6
	mov	r1, #0x0c
	mov	r2, #0x01
	bl	i2csendbyte
	b	reset


.global i2csendbyte
i2csendbyte:
	mov	r3, #0
@fallthrough

.global i2csend
i2csend:
	stmfd	sp!, {r4,lr}
	mov	r12, #0x3C000000
	add	r12, r12, #0x00900000
	mov	r4, #0
	str	r4, [r12,#0x08]
	str	r0, [r12,#0x0c]
	mov	r4, #0xf0
	str	r4, [r12,#0x04]
	mov	r4, #0xf3
	str	r4, [r12]
	bl	i2cwait
	str	r1, [r12,#0x0c]
	str	r4, [r12]
	bl	i2cwait
	movs	r3, r3
	moveq	r0, r2
i2csend_write:
	ldrne	r0, [r2], #1
	str	r0, [r12,#0x0c]
	str	r4, [r12]
	bl	i2cwait
	subs	r3, r3, #1
	bhi	i2csend_write
	mov	r0, #0xd0
	str	r0, [r12,#0x04]
	str	r4, [r12]
i2csend_wait:
	ldr	r0, [r12,#0x04]
	tst	r0, #0x20
	bne	i2csend_wait
	ldmfd	sp!, {r4,pc}

.global i2crecvbyte
i2crecvbyte:
	mov	r2, #0
	mov	r3, #1
@fallthrough

@.global i2crecv
@i2crecv:
@	stmfd	sp!, {r0,r4,lr}
@	mov	r12, #0x3C000000
@	add	r12, r12, #0x00900000
@	mov	r4, #0
@	str	r4, [r12,#0x08]
@	str	r0, [r12,#0x0c]
@	mov	r4, #0xf0
@	str	r4, [r12,#0x04]
@	mov	r4, #0xf3
@	str	r4, [r12]
@	bl	i2cwait
@	str	r1, [r12,#0x0c]
@	str	r4, [r12]
@	bl	i2cwait
@	ldr	r0, [sp]
@	orr	r0, r0, #1
@	str	r1, [r12,#0x0c]
@	mov	r0, #0xb0
@	str	r0, [r12,#0x04]
@	str	r4, [r12]
@	bl	i2cwait
@i2crecv_read:
@	subs	r3, r3, #1
@	moveq	r4, #0x73
@	str	r4, [r12]
@	bl	i2cwait
@	ldr	r0, [r12,#0x0c]
@	movs	r2, r2
@	strne	r0, [r2], #1
@	movs	r3, r3
@	bne	i2crecv_read
@	mov	r1, #0x90
@	str	r1, [r12,#0x04]
@	mov	r1, #0xf3
@	str	r1, [r12]
@i2crecv_wait:
@	ldr	r1, [r12,#0x04]
@	tst	r1, #0x20
@	bne	i2crecv_wait
@	ldmfd	sp!, {r0,r4,pc}
 
i2cwait:
	ldr	r0, [r12]
	tst	r0, #0x10
	beq	i2cwait
	mov	pc, lr

.global exec
exec:
	mov	r2, r0
	bl	clean_dcache
	msr	cpsr_c, #0xd3
	mrc	p15, 0, R0,c1,c0
	bic	r0, r0, #1
	mcr	p15, 0, r0,c1,c0
	mcr	p15, 0, r0,c7,c5
	mov	pc, r2
