OUTPUT_FORMAT(elf32-littlearm)
OUTPUT_ARCH(arm)
ENTRY(_start)

MEMORY
{
  SRAM : ORIGIN = 0x22000000, LENGTH = 0x0002B000
  SDRAM : ORIGIN = 0x09f00000, LENGTH = 0x00100000
}

SECTIONS
{

  .text : {
    *(.text*)
    *(.glue_7)
    *(.glue_7t)
    *(.rodata*)
    *(.data);
  } > SRAM

  . = ALIGN(4);
  .bss : {
    __bss_start__ = . ;
    *(.bss)
    *(COMMON);
    __bss_end__ = . ;
    . += 0x4000;
    __stack_top__ = . ;
  } > SRAM
  
  .buffers : {
    *(.bss.buffers)
  } > SDRAM

}