//
//
//    Copyright 2009 TheSeven
//
//
//    This file is part of iLoader.
//
//    TheSeven's iBugger is free software: you can redistribute it and/or
//    modify it under the terms of the GNU General Public License as
//    published by the Free Software Foundation, either version 2 of the
//    License, or (at your option) any later version.
//
//    TheSeven's iBugger is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//    See the GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with iLoader.  If not, see <http://www.gnu.org/licenses/>.
//
//


#include <toolkit.h>
#include <timer.h>


#define nor ((uint8_t*)0x24000000)
#define norword ((uint32_t*)0x24000000)
#define sysi ((uint8_t*)0x2202bdf0)
#define sysiword ((uint32_t*)0x2202bdf0)


extern void rendertext(void* buffer, uint32_t fgcol, uint32_t bgcol, char* text);
extern void renderbmp(void* buffer, void* bitmap);
extern void fillrect(void* buffer, uint32_t width, uint32_t height, uint32_t color);
extern void displaylcd(uint32_t startx, uint32_t endx, uint32_t starty,
                       uint32_t endy, void* data, uint32_t color);
extern void i2csend(uint32_t device, uint32_t address, void* data, uint32_t length);
extern void i2crecv(uint32_t device, uint32_t address, void* data, uint32_t length);
extern void i2csendbyte(uint32_t device, uint32_t address, uint32_t data);
extern uint32_t i2crecvbyte(uint32_t device, uint32_t address);
extern void poweroff() __attribute__((noreturn));
extern void exec(uint32_t addr) __attribute__((noreturn));
extern uint32_t ucl_nrv2e_decompress_8(const void* src, uint32_t len_src, void* dst, uint32_t* plen_dst);


uint16_t lcdbuffer[0x5AC0] __attribute__((section(".bss.buffers")));
uint16_t backdrop[0x5AC0] __attribute__((section(".bss.buffers")));

uint32_t config[0x4000];


uint32_t readnor(const char* filename, void* address, uint32_t* size)
{
    uint32_t i;
    for (i = 0; i < 0x1000; i += 0x10)
        if (memcmp(&nor[i], filename, 8) == 0)
        {
            *size = norword[(i + 0xc) >> 2];
            if ((*size) & 0x80000000)
                return ucl_nrv2e_decompress_8(&nor[norword[(i + 0x8) >> 2]],
                                              (*size) & 0x7fffffff, address, size);
            else memcpy(address, &nor[norword[(i + 0x8) >> 2]], *size);
            return 0;
        }
    return 1;
}

uint32_t readfile(uint32_t dir, const char* filename, void* address, uint32_t* size)
{
    if (!dir) return readnor(filename, address, size);
    if (dir < 2) return 1;
    uint32_t file = fat32_get_direntry(dir, filename, size);
    if (file < 2) return 1;
    file = fat32_get_clusterchain(file, (*size) + 0x7FF, address);
    if (file) return 1;
    return 0;
}

void backlight(uint32_t state, uint32_t brightness, uint32_t fade)
{
    i2csendbyte(0xE6, 0x2B, fade);
    i2csendbyte(0xE6, 0x2A, 6);
    i2csendbyte(0xE6, 0x28, brightness);
    i2csendbyte(0xE6, 0x29, state);
}

void waitwheelrelease(uint32_t timeout)
{
    uint32_t timestamp = USEC_TIMER;
    while (1)
    {
        if (timeout && TIMEOUT_EXPIRED(timestamp, timeout)) break;
        uint32_t events = WHEELINT;
        if (events & 4) WHEELINT = 4;
        if (events & 2) WHEELINT = 2;
        if (events & 1)
        {
            uint32_t data = WHEELRX;
            WHEELINT = 1;
            if ((data & 0x80001FFF) == 0x8000001A) break;
        }
    }
}

void fallbackcfg()
{
    uint32_t i;
    for (i = 0; i < 0x4000; i++) config[i] = 0;
    for (i = 0; i < 0x20; i++) config[i] = 0x8C;
    memcpy(&config[0x20], "\x88\0\0\0\x88\0\0\0\x0f\0\0\0\0\0\0\0\x0a\0\0\0\0\0\0\0\0\0\0\0\xb0\0\0\0"
                          "\x84\0\0\0\0\0\0\0\x0b\0\0\0\0\0\0\0\0\0\0\0\xff\xff\0\0\0\0\0\0\xf4\0\0\0"
                          "\x0e\0\0\0\x01\0\0\0\x20\0\0\0\x20\0\0\0\x09\0\0\0\x18\x01\0\0\0\0\0\0"
                          "\xff\xff\xff\xff\xfe\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff\x80\xc3"
                          "\xc9\x01\x0f\0\0\0iLoader - no config file!\0power off\0\x0e\x01\0\0\0\0\0"
                          "\0\x0c\0\0\0\xff\xff\0\0\0\0\0\0\xff\xe0\0\0\0\x1f\0\0\x88\0\0", 184);
    uint32_t found = 0;
    uint32_t x = 0;
    uint32_t y = 12;
    for (i = 0; i < 0x400; i += 4)
        if (norword[i] != 0x00000000 && norword[i] != 0xffffffff)
        {
            y += 8;
            found++;
            if (found == 45) break;
            else if (found == 30)
            {
                x = 128;
                y = 12;
            }
            else if (found == 15)
            {
                x = 64;
                y = 12;
            }
            memcpy(&((uint8_t*)config)[0xa0c + 9 * found], &norword[i], 8);
            ((uint8_t*)config)[0xa0c + 9 * found + 8] = 0;
            config[0x46 + found * 8] = 0xa0c + 9 * found;
            config[0x47 + found * 8] = x;
            config[0x48 + found * 8] = y;
            config[0x49 + found * 8] = 0xffff;
            config[0x4a + found * 8] = 0x0000;
            config[0x4b + found * 8] = 0xe0ff;
            config[0x4c + found * 8] = 0x1f00;
            config[0x4d + found * 8] = 0x69c + found * 20;
            config[0x1a7 + found * 5] = 0x04;
            config[0x1a8 + found * 5] = 0x08000000;
            config[0x1a9 + found * 5] = 0xa0c + 9 * found;
            config[0x1aa + found * 5] = 0x13;
            config[0x1ab + found * 5] = 0x08000000;
        }
}

void main(void)
{
    uint32_t i;
    uint32_t dir = 0;
    uint32_t pc = 0;
    uint32_t size;
    uint32_t errhandler;

    PCON15 = (PCON15 & ~0xFFFF0000) | 0x22220000;
    PUNK15 = 0xF0;
    WHEEL08 = 0x3A980;
    WHEEL00 = 0x280000;
    WHEEL10 = 3;
    PCON10 = (PCON10 & ~0xFF0) | 0x10;
    PDAT10 |= 2;
    WHEELTX = 0x8000023A;
    WHEEL04 |= 1;
    PDAT10 &= ~2;
    uint32_t timestamp = USEC_TIMER;
    while (!TIMEOUT_EXPIRED(timestamp, 10000))
    {
        uint32_t events = WHEELINT;
        if (events & 4) WHEELINT = 4;
        if (events & 2) WHEELINT = 2;
        if (events & 1)
        {
            uint32_t data = WHEELRX;
            WHEELINT = 1;
            if ((data & 0x8000FFFF) == 0x8000023A && (data & 0x1F0000))
            {
                pc = (data >> 16) & 0x1F;
                waitwheelrelease(1000000);
                break;
            }
        }
    }

    i2csendbyte(0xE6, 0x35, 0x15);
    i2csendbyte(0xE6, 0x36, 0x01);
    PWRCON &= ~0x10;
    if (fat32_init() == 0) dir = fat32_get_direntry(fat32_get_root(), "ILOADER    ", &size);
    else pc = 0x20;

    uint32_t scfg_size = norword[0x401];
    uint32_t scfg_entrycount = norword[0x405];
    if (norword[0x400] == 0x53436667 && scfg_size <= 0x1000
     && scfg_entrycount * 0x14 + 0x18 == scfg_size)
    {
        memset(sysi, 0, 0x104);
        sysiword[0] = 0x53797349;
        sysiword[1] = 0x104;
        sysiword[0x21] = 0x100000;
        for (i = 0; i < scfg_entrycount; i++)
            switch (norword[0x406 + i * 5])
            {
                case 0x48774e6d: // HwNm
                    memcpy(&sysi[0x08], &norword[0x406 + i * 5 + 1], 16);
                    break;
                case 0x48775672: // HwVr
                    if (norword[0x406 + i * 5 + 1] == 0)
                        sysiword[0x21] = norword[0x406 + i * 5 + 2];
                    break;
                case 0x53724e6d: // SrNm
                    memcpy(&sysi[0x18], &norword[0x406 + i * 5 + 1], 16);
                    break;
                case 0x46774964: // FwId
                    if (nor[0x1018 + i * 0x14 + 7] == 0)
                    {
                        memcpy(&sysi[0x38], &norword[0x406 + i * 5 + 2], 3);
                        sysi[0x3b] = 2;
                        sysiword[0xf] = 0xa2700;
                    }
                    else memcpy(&sysi[0x38], &norword[0x406 + i * 5 + 2], 8);
                    memset(&sysi[0x40], 10, 0);
                    break;
                case 0x556e7443: // UntC
                    memcpy(&sysi[0xbc], &norword[0x406 + i * 5 + 1], 16);
                    break;
                case 0x52746341: // RtcA
                    if (norword[0x406 + i * 5 + 1] == 1)
                        sysiword[0x80] = norword[0x406 + i * 5 + 2];
                    break;
                case 0x42747279: // Btry
                    if (norword[0x406 + i * 5 + 1] == 1)
                        memcpy(&sysi[0x5c], &norword[0x406 + i * 5 + 2], 12);
                    break;
                case 0x5265676e: // Regn
                    if (nor[0x1018 + i * 0x14 + 4] == 1 && nor[0x1018 + i * 0x14 + 5] == 0)
                        memcpy(&sysi[0x92], &norword[0x406 + i * 5 + 2], 4);
                    break;
                case 0x4d6f6423: // Mod#
                    memcpy(&sysi[0x98], &norword[0x406 + i * 5 + 1], 16);
                    break;
                case 0x48774f31: // Hw01
                    memcpy(&sysi[0xa8], &norword[0x406 + i * 5 + 1], 16);
                    break;
                case 0x436f6e74: // Cont
                    if (nor[0x1018 + i * 0x14 + 4] == 0 && nor[0x1018 + i * 0x14 + 5] == 0)
                    {
                        sysi[0xb8] = nor[0x1018 + i * 0x14 + 6];
                        sysi[0xb9] = nor[0x1018 + i * 0x14 + 8];
                    }
                    break;
                case 0x426b4c74: // BkLt
                    if (nor[0x1018 + i * 0x14 + 4] == 0xaa && nor[0x1018 + i * 0x14 + 5] == 0x55)
                    {
                        sysi[0xba] = nor[0x1018 + i * 0x14 + 6];
                        sysi[0xbb] = nor[0x1018 + i * 0x14 + 8];
                    }
                    break;
                case 0x44726d56: // DrmV
                    memcpy(&sysi[0xce], &norword[0x406 + i * 5 + 1], 16);
                    break;
            }
        sysiword[2] = 0x646f5069;
        sysiword[3] = 0x36334e20;
        sysi[0x88] = 0x4e;
        sysi[0x89] = 0x41;
        sysiword[0x38] = 0x2000000;
        sysiword[0x39] = 0x8000000;
        sysiword[0x3a] = 0x2c000;
        sysiword[0x3b] = 0x22000000;
        sysiword[0x3c] = 0x100000;
        sysiword[0x3d] = 0x24000000;
        sysiword[0x4a] = 0x53797349;
        sysiword[0x4b] = 0x2202bdf0;
    }

    if (dir && !readfile(dir, "ILOADER CFG", config, &size));
    else if (!readnor("ildrcfg ", config, &size));
    else
    {
        fallbackcfg();
        pc = 0;
    }
    pc = config[pc] >> 2;
    errhandler = config[0x21] >> 2;

    while (1)
    {
        if (pc >= 0x4000)
        {
            fallbackcfg();
            pc = 0x23;
        }

        uint32_t oldpc = pc;

        switch (config[pc])
        {
            case 0x0:
                dir = 0;
                pc++;
                break;

            case 0x1:
                dir = fat32_get_root();
                if (dir < 2) pc = errhandler;
                else pc++;
                break;

            case 0x2:
                dir = fat32_get_direntry(fat32_get_root(), "ILOADER    ", &size);
                if (dir < 2) pc = errhandler;
                else pc++;
                break;

            case 0x3:
                dir = fat32_get_direntry(dir, &((uint8_t*)config)[config[pc + 1]], &size);
                if (dir < 2) pc = errhandler;
                else pc += 2;
                break;

            case 0x4:
                if (readfile(dir, &((uint8_t*)config)[config[pc + 2]], (void*)config[pc + 1], &size))
                    pc = errhandler;
                else pc += 3;
                break;

            case 0x5:
                pc = config[pc + 2] >> 2;
                if (readfile(dir, &((uint8_t*)config)[config[oldpc + 1]], config, &size))
                    pc = errhandler;
                break;

            case 0x6:
                errhandler = config[pc + 1] >> 2;
                pc += 2;
                break;

            case 0x7:
                pc = config[pc + 1] >> 2;
                break;

            case 0x8:
                {
                    uint32_t timestamp = USEC_TIMER;
                    while (1)
                    {
                        if (config[pc + 6] && TIMEOUT_EXPIRED(timestamp, config[pc + 6]))
                        {
                            pc += 7;
                            break;
                        }
                        uint32_t events = WHEELINT;
                        if (events & 4) WHEELINT = 4;
                        if (events & 2) WHEELINT = 2;
                        if (events & 1)
                        {
                            uint32_t data = WHEELRX;
                            WHEELINT = 1;
                            if ((data & 0x800000FF) == 0x8000001A && (data & 0x1F00))
                            {
                                if (data & 0x100) pc = config[pc + 1] >> 2;
                                else if (data & 0x200) pc = config[pc + 2] >> 2;
                                else if (data & 0x400) pc = config[pc + 3] >> 2;
                                else if (data & 0x800) pc = config[pc + 4] >> 2;
                                else if (data & 0x1000) pc = config[pc + 5] >> 2;
                                waitwheelrelease(0);
                                break;
                            }
                        }
                    }
                }
                break;

            case 0x9:
                {
                    uint32_t timestamp = USEC_TIMER;
                    uint32_t timeout = config[pc + 7];
                    memcpy(backdrop, lcdbuffer, 0xB580);
                    uint32_t ci = (config[pc + 1] >> 2) + 8 * config[pc + 2];
                    while (1)
                    {
                        memcpy(lcdbuffer, backdrop, 0xB580);
                        uint32_t di = (config[pc + 1] >> 2);
                        while (config[di])
                        {
                            rendertext(&lcdbuffer[config[di + 1] + 176 * config[di + 2]],
                                       config[di + (di == ci ? 5 : 3)], config[di + (di == ci ? 6 : 4)],
                                       &((uint8_t*)config)[config[di]]);
                            di += 8;
                        }
                        displaylcd(0, 175, 0, 131, lcdbuffer, 0);

                        uint32_t button;
                        int oldpos = 0;
                        uint32_t finger = 0;
                        while (1)
                        {
                            if (timeout && TIMEOUT_EXPIRED(timestamp, timeout))
                            {
                                pc += 8;
                                goto menu_end;
                            }
                            uint32_t events = WHEELINT;
                            if (events & 4) WHEELINT = 4;
                            if (events & 2) WHEELINT = 2;
                            if (events & 1)
                            {
                                uint32_t data = WHEELRX;
                                WHEELINT = 1;
                                if ((data & 0x800000FF) == 0x8000001A)
                                {
                                    if (data & 0x1F00)
                                    {
                                        button = (data >> 8) & 0x1f;
                                        break;
                                    }
                                    else if (!(data & 0x40000000)) finger = 0;
                                    else if (!finger)
                                    {
                                        finger = 1;
                                        oldpos = (data >> 16) & 0xff;
                                    }
                                    else
                                    {
                                        int newpos = (data >> 16) & 0xff;
                                        if (newpos > 72 && oldpos < 24) newpos -= 96;
                                        else if (oldpos > 72 && newpos < 24) newpos += 96;
                                        if (oldpos - newpos > 10)
                                        {
                                            button = 0x20;
                                            break;
                                        }
                                        if (newpos - oldpos > 10)
                                        {
                                            button = 0x40;
                                            break;
                                        }
                                    }
                                }
                            }
                        }

                        timeout = 0;

                        if ((button & 1) && config[ci + 7])
                        {
                            pc = config[ci + 7] >> 2;
                            waitwheelrelease(0);
                            break;
                        }
                        if (button & 2)
                        {
                            if (config[pc + 3] == 0xfffffffe) {if (ci > (config[pc + 1] >> 2)) ci -= 8;}
                            else if (config[pc + 3] == 0xffffffff) {if (config[ci + 8]) ci += 8;}
                            else if (config[pc + 3])
                            {
                                pc = config[pc + 3] >> 2;
                                waitwheelrelease(0);
                                break;
                            }
                        }
                        if (button & 4)
                        {
                            if (config[pc + 4] == 0xfffffffe) {if (ci > (config[pc + 1] >> 2)) ci -= 8;}
                            else if (config[pc + 4] == 0xffffffff) {if (config[ci + 8]) ci += 8;}
                            else if (config[pc + 4])
                            {
                                pc = config[pc + 4] >> 2;
                                waitwheelrelease(0);
                                break;
                            }
                        }
                        if (button & 8)
                        {
                            if (config[pc + 5] == 0xfffffffe) {if (ci > (config[pc + 1] >> 2)) ci -= 8;}
                            else if (config[pc + 5] == 0xffffffff) {if (config[ci + 8]) ci += 8;}
                            else if (config[pc + 5])
                            {
                                pc = config[pc + 5] >> 2;
                                waitwheelrelease(0);
                                break;
                            }
                        }
                        if (button & 16)
                        {
                            if (config[pc + 6] == 0xfffffffe) {if (ci > (config[pc + 1] >> 2)) ci -= 8;}
                            else if (config[pc + 6] == 0xffffffff) {if (config[ci + 8]) ci += 8;}
                            else if (config[pc + 6])
                            {
                                pc = config[pc + 6] >> 2;
                                waitwheelrelease(0);
                                break;
                            }
                        }
                        if ((button & 32) && ci > (config[pc + 1] >> 2)) ci -= 8;
                        if ((button & 64) && config[ci + 8]) ci += 8;
                        if (button & 31) waitwheelrelease(200000);
                    }
                }
                menu_end: break;

            case 0xa:
                fillrect(&lcdbuffer[config[pc + 1] + 176 * config[pc + 2]],
                         config[pc + 3], config[pc + 4], config[pc + 5]);
                pc += 6;
                break;

            case 0xb:
                rendertext(&lcdbuffer[config[pc + 1] + 176 * config[pc + 2]],
                           config[pc + 3], config[pc + 4], &((uint8_t*)config)[config[pc + 5]]);
                pc += 6;
                break;

            case 0xc:
                renderbmp(&lcdbuffer[config[pc + 1] + 176 * config[pc + 2]], (void*)config[pc + 3]);
                pc += 4;
                break;

            case 0xd:
                displaylcd(0, 175, 0, 131, lcdbuffer, 0);
                pc++;
                break;

            case 0xe:
                backlight(config[pc + 1], config[pc + 2], config[pc + 3]);
                pc += 4;
                break;

            case 0xf:
                poweroff();

            case 0x10:
                {
                    uint8_t* image = (uint8_t*)config[pc + 1];
                    uint32_t checksum = image[3] | (image[2] << 8) | (image[1] << 16) | (image[0] << 24);
                    uint32_t mysum = 62;
                    if (*((uint32_t*)&image[4]) != 0x67326E6E) pc = errhandler;
                    else
                    {
                        for (i = 0; i < size - 8; i++)
                        {
                            image[i] = image[i + 8];
                            mysum += image[i + 8];
                        }
                        if (checksum != mysum) pc = errhandler;
                        else pc = pc + 2;
                    }
                }
                break;

            case 0x11:
                sleep(config[pc + 1]);
                pc += 2;
                break;

            case 0x12:
                PWRCON = config[pc + 1];
                PWRCONEXT = config[pc + 2];
                pc += 3;
                break;

            case 0x13:
                exec(config[pc + 1]);

            case 0x14:
                if (ucl_nrv2e_decompress_8((void*)config[pc + 1], size, (void*)config[pc + 2], &size))
                    pc = errhandler;
                else pc += 3;
                break;

            default:
                fallbackcfg();
                pc = 0x23;
        }
    }
}
