#!/usr/bin/env python
#
#
#    Copyright 2010 TheSeven
#
#
#    This file is part of iLoader.
#
#    TheSeven's iBugger is free software: you can redistribute it and/or
#    modify it under the terms of the GNU General Public License as
#    published by the Free Software Foundation, either version 2 of the
#    License, or (at your option) any later version.
#
#    TheSeven's iBugger is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#    See the GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with iLoader.  If not, see <http://www.gnu.org/licenses/>.
#
#


import sys
import struct

flashfiles = [("diskmode", "diskflsh.bin"), \
              ("diagmode", "diagflsh.bin"), \
              ("ibugger ", "ibugger.bin"), \
              ("nandfsck", "nandfsck.bin"), \
              ("ildrcfg ", "iloader.cfg"), \
              ("bmmenu  ", "menu.bmp"), \
              ("bmdiag  ", "appleos.bmp"), \
              ("bmrockbx", "rockbox.bmp")]

file = open(sys.argv[1], "rb")
iloader = file.read()
file.close()
iloader = iloader.ljust((len(iloader) + 0xfff) & 0xfffff000, "\xff")

data = ""
dir = ""

for f in flashfiles:
  file = open("flashfiles/" + f[1], "rb")
  fdata = file.read()
  file.close()
  data = fdata.ljust((len(fdata) + 0xfff) & 0xfffff000, "\xff") + data
  addr = 0xff000 - len(data)
  dir = dir + f[0].ljust(8, " ") + struct.pack("<II", addr, len(fdata))

dir = dir.ljust(0x1000, "\xff")

totalsize = len(iloader) + len(data) + len(dir)
print("")
print("%d out of %d bytes of flash space used (%d %%)" \
    % (totalsize, 0xf0000, totalsize * 100 / 0xf0000))
if totalsize > 0xf0000:
  print("Out of flash space! (Need %d bytes)" % (0xf0000 - totalsize))
  exit(3)
print("")

data = iloader + data.rjust(0xef000 - len(iloader), "\xff") + dir

file = open(sys.argv[2], "wb")
file.write(data)
file.close()
