.global _start
_start:
	msr	cpsr_c, #0xd3
	mrc	p15, 0, R0,c1,c0
	bic	r0, r0, #5
	mcr	p15, 0, r0,c1,c0
	adr	lr, cacheflush_done

flushcache:
	mov	r0, #0
flushcache_loop:
	mcr	p15, 0, r0,c7,c14,2
	add	r1, r0, #0x10
	mcr	p15, 0, r1,c7,c14,2
	add	r1, r1, #0x10
	mcr	p15, 0, r1,c7,c14,2
	add	r1, r1, #0x10
	mcr	p15, 0, r1,c7,c14,2
	adds	r0, r0, #0x04000000
	bne	flushcache_loop
	mcr	p15, 0, r0,c7,c10,4
	mcr	p15, 0, r0,c7,c5
	mov	pc, lr

cacheflush_done:
	mov	r1, #0x3F
	mcr	p15, 0, r1,c6,c0,1     @ CS0: 4GB at offset 0 - everything
	mcr	p15, 0, r1,c6,c0,0     @ DS0: 4GB at offset 0 - everything
	mov	r1, #0x31
	mcr	p15, 0, r1,c6,c1,1     @ CS1: SRAM/SDRAM mirror
	mcr	p15, 0, r1,c6,c1,0     @ DS1: SRAM/SDRAM mirror
	add	r1, r1, #0x08000000
	mcr	p15, 0, r1,c6,c2,1     @ CS2: SDRAM
	mcr	p15, 0, r1,c6,c2,0     @ DS2: SDRAM
	mov	r1, #0x23
	add	r1, r1, #0x22000000
	mcr	p15, 0, r1,c6,c3,1     @ CS3: SRAM
	mcr	p15, 0, r1,c6,c3,0     @ DS3: SRAM
	mov	r1, #0x27
	add	r1, r1, #0x24000000
	mcr	p15, 0, r1,c6,c4,1     @ CS4: NOR flash
	mcr	p15, 0, r1,c6,c4,0     @ DS4: NOR flash
	mcr	p15, 0, r0,c6,c5,1     @ CS5: unused
	mcr	p15, 0, r0,c6,c5,0     @ DS5: unused
	mcr	p15, 0, r0,c6,c6,1     @ CS6: unused
	mcr	p15, 0, r0,c6,c6,0     @ DS6: unused
	mcr	p15, 0, r0,c6,c7,1     @ CS7: unused
	mcr	p15, 0, r0,c6,c7,0     @ DS7: unused
	mov	r0, #0x1e
	mcr	p15, 0, r0,c2,c0, 1    @ CS1-4: cacheable
	mcr	p15, 0, r0,c2,c0, 0    @ DS1-4: cacheable
	mcr	p15, 0, r0,c3,c0, 0    @ DS1-4: write cacheable
	mov	r0, #0x300
	add	r0, r0, #0xff
	mcr	p15, 0, r0,c5,c0, 1    @ CS0-4: full access
	mcr	p15, 0, r0,c5,c0, 0    @ DS0-4: full access
	mrc	p15, 0, r0,c1,c0
	orr	r0, r0, #5
	orr	r0, r0, #0x1000
	mcr	p15, 0, r0,c1,c0

	ldr	r0, =ucl_start
	ldr	r1, =ucl_len
	ldr	r1, [r1]
	mov	r2, #0x22000000
	mov	r3, #0x08000000
	mov	sp, #0x0a000000
	bl	ucl_nrv2e_decompress_8
	bl	flushcache
	mov	pc, #0x22000000
