#!/usr/bin/env python
#
#
#    Copyright 2010 TheSeven
#
#
#    This file is part of iLoader.
#
#    TheSeven's iBugger is free software: you can redistribute it and/or
#    modify it under the terms of the GNU General Public License as
#    published by the Free Software Foundation, either version 2 of the
#    License, or (at your option) any later version.
#
#    TheSeven's iBugger is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#    See the GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with iLoader.  If not, see <http://www.gnu.org/licenses/>.
#
#


import sys
import struct

flashfiles = [("diskmode", 1, 0, 2), \
              ("diagmode", 1, 0, 4), \
              ("iloader ", 4, 2, 0, "iloader.bin"), \
              ("nandfsck", 2, 0, 0, "nandfsck.ucl"), \
              ("norloader", 4, 8, 0, "norloader.dfu"), \
              ("ibugger ", 1, 0, 0, "ibugger.bin"), \
              ("ildrcfg ", 1, 0, 0, "iloader.cfg"), \
              ("bmwelcom", 3, 0, 0, "welcome.ucl"), \
              ("bmnothem", 3, 0, 0, "notheme.ucl")]

firstinstfiles = []

commonfiles = [(1,), \
               (2, "ILOADER    "), \
               (5, "NORFLASHBAK"), \
               (6, "APPLEOS BIN")]

file = open(sys.argv[1], "rb")
installer = file.read()
file.close()

scriptsize = 12
for f in flashfiles:
  scriptsize = scriptsize + 4
  if (f[1] & 4) == 0: scriptsize = scriptsize + 8
  if f[3] == 0: scriptsize = scriptsize + 8

for f in firstinstfiles:
  scriptsize = scriptsize + 4
  if len(f) > 1: scriptsize = scriptsize + 8
  if len(f) > 2: scriptsize = scriptsize + 8

for f in commonfiles:
  scriptsize = scriptsize + 4
  if len(f) > 1: scriptsize = scriptsize + 8
  if len(f) > 2: scriptsize = scriptsize + 8

filedata = ""
flash = ""
for f in flashfiles:
  flash = flash + struct.pack("BBBB", f[3], f[1], f[2], 1)
  if f[3] == 0:
    file = open("flashfiles/" + f[4], "rb")
    fdata = file.read()
    file.close()
    flash = flash + struct.pack("<II", scriptsize + len(filedata), len(fdata))
    filedata = filedata + fdata.ljust((len(fdata) + 3) & ~3)
  if (f[1] & 4) == 0: flash = flash + f[0]

firstinstall = ""
for f in firstinstfiles:
  firstinstall = firstinstall + struct.pack("B", f[0])
  if len(f) > 1: firstinstall = firstinstall + f[1]
  else: firstinstall = firstinstall + struct.pack("BBB", 0, 0, 0)
  if len(f) > 2:
    file = open("datafiles/" + f[2], "rb")
    fdata = file.read()
    file.close()
    firstinstall = firstinstall + struct.pack("<II", scriptsize + len(filedata), len(fdata))
    filedata = filedata + fdata.ljust((len(fdata) + 3) & ~3)

common = ""
for f in commonfiles:
  common = common + struct.pack("B", f[0])
  if len(f) > 1: common = common + f[1]
  else: common = common + struct.pack("BBB", 0, 0, 0)
  if len(f) > 2:
    file = open("datafiles/" + f[2], "rb")
    fdata = file.read()
    file.close()
    common = common + struct.pack("<II", scriptsize + len(filedata), len(fdata))
    filedata = filedata + fdata.ljust((len(fdata) + 3) & ~3)

file = open(sys.argv[2], "wb")
file.write(installer + flash + struct.pack("<II", 0, len(flash) + 8 + len(firstinstall)) \
         + firstinstall + common + struct.pack("<I", 0) + filedata)
file.close()
