ucl_nrv2e_decompress_8: .globl ucl_nrv2e_decompress_8 @ ARM mode
        .type ucl_nrv2e_decompress_8, %function



        adr r12,1+.thumb_nrv2e_d8; bx r12 @ enter THUMB mode
        .code 16 @ THUMB mode
        .thumb_func

.thumb_nrv2e_d8:
        push {r2,r3,r4,r5,r6,r7,lr}
        add r7,r1,r0 @ r7= eof_src;
        mov r4,#1; neg r5,r4 @ r5= -1 initial condition
        lsl r4,#31 @ 1<<31: refill next time
        mov r6,#5
        lsl r6,#8 @ 0x500 @ nrv2e M2_MAX_OFFSET
        b top_n2e

eof_n2e:
        pop {r3,r4} @ r3= orig_dst; r4= plen_dst
        sub r0,r7 @ 0 if actual r0 length equals expected length
        sub r2,r3 @ actual r2 length
        str r2,[r4]
        pop {r4,r5,r6,r7}
        pop {r1}
        bx r1

lit_n2e:
        ldrb r3,[r0]; add r0,#1
        strb r3,[r2]; add r2,#1
top_n2e:
        add r4,r4; mov lr,pc; beq get1_n2e; bcs lit_n2e
        mov r1,#1; b getoff_n2e

off_n2e:
        sub r1,#1
        add r4,r4; mov lr,pc; beq get1_n2e; adc r1,r1
getoff_n2e:
        add r4,r4; mov lr,pc; beq get1_n2e; adc r1,r1
        add r4,r4; mov lr,pc; beq get1_n2e; bcc off_n2e

        sub r3,r1,#3 @ set Carry
        mov r1,#0 @ Carry unaffected
        blo offprev_n2e @ r1 was 2; tests Carry only
        lsl r3,#8
        ldrb r5,[r0]; add r0,#1 @ low 7+1 r4
        orr r5,r3
        mvn r5,r5; beq eof_n2e @ r5= ~r5
        asr r5,#1; bcs lenlast_n2e
        b lenmore_n2e

offprev_n2e:
        add r4,r4; mov lr,pc; beq get1_n2e; bcs lenlast_n2e
lenmore_n2e:
        mov r1,#1
        add r4,r4; mov lr,pc; beq get1_n2e; bcs lenlast_n2e
len_n2e:
        add r4,r4; mov lr,pc; beq get1_n2e; adc r1,r1
        add r4,r4; mov lr,pc; beq get1_n2e; bcc len_n2e
        add r1,#6-2
        b gotlen_n2e

lenlast_n2e:
        add r4,r4; mov lr,pc; beq get1_n2e; adc r1,r1 @ 0,1,2,3
        add r1,#2
gotlen_n2e: @ 'cmn': add the inputs, set condition codes, discard the sum
        cmn r6,r5; bcs near_n2e @ within M2_MAX_OFFSET
        add r1,#1 @ too far away, so minimum match length is 3
near_n2e:
        ldrb r3,[r2] @ force cacheline allocate
copy_n2e:
        ldrb r3,[r2,r5]
        strb r3,[r2]; add r2,#1
        sub r1,#1; bne copy_n2e
        b top_n2e

get1_n2e: @ In: Carry set [from adding 0x80000000 (1<<31) to itself]
          ldrb r4,[r0] @ zero-extend next byte
        adc r4,r4 @ double and insert CarryIn as low bit
          add r0,#1
        lsl r4,#24 @ move to top byte, and set CarryOut from old bit 8
        mov pc,lr @ return, stay in current (THUMB) mode

        .size ucl_nrv2e_decompress_8, .-ucl_nrv2e_decompress_8


        .code 32
ucl_nrv2e_test_8: .globl ucl_nrv2e_test_8 @ ARM mode
        .type ucl_nrv2e_test_8, %function



        adr r12,1+.thumb_nrv2e_d8_test; bx r12 @ enter THUMB mode
        .code 16 @ THUMB mode
        .thumb_func

.thumb_nrv2e_d8_test:
        push {r3,r4,r5,r6,r7,lr}
        mov r2,#0
        add r7,r1,r0 @ r7= eof_src;
        mov r4,#1; neg r5,r4 @ r5= -1 initial condition
        lsl r4,#31 @ 1<<31: refill next time
        mov r6,#5
        lsl r6,#8 @ 0x500 @ nrv2e M2_MAX_OFFSET
        b top_n2e_test

eof_n2e_test:
        pop {r4} @ r4= plen_dst
        sub r0,r7 @ 0 if actual r0 length equals expected length
        str r2,[r4]
        pop {r4,r5,r6,r7}
        pop {r1}
        bx r1

lit_n2e_test:
        add r0,#1
        add r2,#1
top_n2e_test:
        add r4,r4; mov lr,pc; beq get1_n2e; bcs lit_n2e_test
        mov r1,#1; b getoff_n2e_test

off_n2e_test:
        sub r1,#1
        add r4,r4; mov lr,pc; beq get1_n2e; adc r1,r1
getoff_n2e_test:
        add r4,r4; mov lr,pc; beq get1_n2e; adc r1,r1
        add r4,r4; mov lr,pc; beq get1_n2e; bcc off_n2e_test

        sub r3,r1,#3 @ set Carry
        mov r1,#0 @ Carry unaffected
        blo offprev_n2e_test @ r1 was 2; tests Carry only
        lsl r3,#8
        ldrb r5,[r0]; add r0,#1 @ low 7+1 r4
        orr r5,r3
        mvn r5,r5; beq eof_n2e_test @ r5= ~r5
        asr r5,#1; bcs lenlast_n2e_test
        b lenmore_n2e_test

offprev_n2e_test:
        add r4,r4; mov lr,pc; beq get1_n2e; bcs lenlast_n2e_test
lenmore_n2e_test:
        mov r1,#1
        add r4,r4; mov lr,pc; beq get1_n2e; bcs lenlast_n2e_test
len_n2e_test:
        add r4,r4; mov lr,pc; beq get1_n2e; adc r1,r1
        add r4,r4; mov lr,pc; beq get1_n2e; bcc len_n2e_test
        add r1,#6-2
        b gotlen_n2e_test

lenlast_n2e_test:
        add r4,r4; mov lr,pc; beq get1_n2e; adc r1,r1 @ 0,1,2,3
        add r1,#2
gotlen_n2e_test: @ 'cmn': add the inputs, set condition codes, discard the sum
        cmn r6,r5; bcs near_n2e_test @ within M2_MAX_OFFSET
        add r1,#1 @ too far away, so minimum match length is 3
near_n2e_test:
        add r2,r1
        b top_n2e_test

        .size ucl_nrv2e_decompress_8_test, .-ucl_nrv2e_decompress_8_test
